#! /usr/bin/perl

use strict;
use warnings;
use Data::Dumper;
use Linux::Input;

my $kb=Linux::Input->new('/dev/input/event2');

my %keystate;

while(1) {
  while (my @events =$kb->poll(0.05)) {
    for (@events) {
      if($_->{type} == 1) {
        if($_->{value} > 0) {
          $keystate{$_->{code}}='Down';
        } else {
          $keystate{$_->{code}}='Up';
        }
        if($_->{value} == 1) {
          CheckKeyMatches();
        }
      }
    }
  }
}

sub isDown {
  my $key=shift;

  if($keystate{$key} eq 'Down') {
    print $keystate{$key}, "\n";
    print "Key is down! $key\n";
    return 1;
  }
  return undef;
}

sub CheckKeyMatches {
  if(isDown(5)) { #All the shifts are based on this key
    print Dumper(\%keystate);
    if (isDown(21)) {           # up, start game or say yes
      system("runmacro /home/arcade/xmacro/titansattack/play")
    }

    if (isDown(48)) {             #
      system("runmacro /home/arcade/xmacro/titansattack/shields")
    }
    
    if (isDown(18)) {             #
      system("runmacro /home/arcade/xmacro/titansattack/gunpower")
    }
    
    if (isDown(35)) {             #
      system("runmacro /home/arcade/xmacro/titansattack/extrabullets")
    }
    
    if (isDown(50)) {             #
      system("runmacro /home/arcade/xmacro/titansattack/smartbombs")
    }
    
    if (isDown(11)) {             #
      system("runmacro /home/arcade/xmacro/titansattack/addons")
    }
    
    if (isDown(100)) {             #
      system("runmacro /home/arcade/xmacro/titansattack/shipspeed")
    }
    
    if (isDown(49)) {            #
      system("runmacro /home/arcade/xmacro/titansattack/no")
    }
    
  }

  if (isDown(2)) {            #
    system("runmacro /home/arcade/xmacro/titansattack/exit")
  }

  sleep 0.5;
}
